package LCE.model;

public abstract class Gate extends Piece 
{
    public Link collegamento;

    public Gate(int _x, int _y) 
	{
        super(_x, _y);
        collegamento = null;
    }

    public void setLink(Link l) 
	{
        collegamento = l;
    }

    public void refreshOutput() 
	{
        if (collegamento != null) 
		{
            collegamento.valIn = getOutput();
            collegamento.refresh();
        }
    }

    @Override
    abstract public boolean getOutput();//Ottiene il valore in uscita

    @Override
    abstract public void setInput(int index, boolean _in);//Setta i valori in entrata

    @Override
    abstract public void refreshValue();//Aggiorna output
}