package LCE.model;
import LCE.*;
import LCE.controller.*;
import LCE.view.*;

class Link{
	private int idLink;
	public boolean valIn;
	public Piece  succ;
	public int idIn;
	public static int numLink;
	
	//Crea il collegamento tra l'uscita del gate "prec" e l'ingresso passato del gate succ
	public Link(Piece  _prec, Piece  _succ, int _idIn,int _idOut){

		if(! (_prec instanceof Led) ){
			if(_prec instanceof Point){
				((Point)_prec).addLink(this,_idIn);
			}
			if(_prec instanceof Gate)
				((Gate)_prec).setLink(this);
			if(_prec instanceof Input)
				((Input)_prec).setLink(this);
		}
		this.succ = _succ;
		this.idIn = _idOut;
		_prec.refreshValue();
		idLink = numLink;
		numLink++;
	}
	
	//Aggiorna il valore in input della porta succ
	public void refresh(){
		succ.setInput(idIn, valIn);
		succ.refreshValue();
	}
	
	//Restituisce la porta "prec"
	public boolean getInput(){
		return valIn;
	}
	
	//Restituisce la porta "succ"
	public Piece getOutput(){
		return succ;
	}
	
	public int getID(){
		return idLink;
	}
	
	public String toString(){
		return "Linea ID: "+ this.idLink + " porta in uscita " +succ.toString(); 
	}
}