package LCE.view;

import LCE.*;
import LCE.model.*;

import java.awt.*;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import javax.swing.OverlayLayout;
import javax.swing.SwingUtilities;

public class JGatePanel extends JLinkablePanel 
{
    public int typegate;   
    PopupMenu popupmenu = createPopupMenuGatePanel();
	public final int PinMiddle_Coord = 22;
	public final int Pin0_In_Y = 12;
	public final int Pin1_In_Y = 33;

    public JGatePanel(Image _img, MouseEvent e) 
	{
        background = _img;
        effaceable = true;
        setLocation(e.getX() - 24, e.getY() - 24);
        setPreferredSize(new Dimension(background.getWidth(this), background.getHeight(this)));
        setCursor(new Cursor(Cursor.HAND_CURSOR));
		coordInput = new Point[2];

        //Creo un ascoltatore per trascinare gli elementi
        addMouseMotionListener(new MouseMotionAdapter() 
		{
            Component c;
			//Serve per trascinare la JLabel dove vuoi
            @Override
            public void mouseDragged(MouseEvent e) 
			{
                if (refGraphMan.moved == false) 
				{    
                    refGraphMan.moved = true;
                    refGraphMan.tempComp = ((Component) e.getSource()).getLocation();   
                    //Mi salvo gli offset di dove ha premuto per la prima volta sul Panel.
                    refGraphMan.tempX = e.getX();
                    refGraphMan.tempY = e.getY();
                }else{           
                    refGraphMan.tempPointDrag = e.getPoint();   
                    if (SwingUtilities.isLeftMouseButton(e) && !refGraphMan.isCircuitStartedSimulate()) 
					{
                        setCursor(new Cursor(Cursor.MOVE_CURSOR));
                        if (refGraphMan.isComponentDraggable()) 
						{
                            c = e.getComponent();
                            if (!refGraphMan.isOnScreenOfMiddlePanel((JGatePanel) c)) {
                                c.setLocation(c.getX() + e.getX() / 50, c.getY() + e.getY() / 50);
                            } else {
                                //Sottraggo l'offset in modo tale da eliminare il fastidioso effetto "scatto"
                                c.setLocation(c.getX() + e.getX() - refGraphMan.tempX, c.getY() + e.getY() - refGraphMan.tempY);
                            }
                            refGraphMan.setPositionGateInModel(id, (JLinkablePanel)c);
                            refreshPositionLink();
                            refresh();
                            refGraphMan.refreshMiddlePanel((JGatePanel) e.getSource(), e);
                        }
                    }
                }
            }

            @Override
            public void mouseMoved(MouseEvent e) {
                repaint();
            }
        });


        addMouseListener(new MouseAdapter() {

            @Override
            public void mouseClicked(MouseEvent e) {
                refGraphMan.setSelectedJLinkablePanel(((JGatePanel) e.getSource()).id);
                
                //In base a dove viene cliccato setta il rispettivo link
                effetiveLink = setAndGetEffetiveLink(e.getPoint());
                
                //Genera un popup menu' cliccando con il tasto destro
                if (SwingUtilities.isRightMouseButton(e)) {
                    popupmenu.show((JGatePanel) e.getSource(), e.getX(), e.getY());
                }
                
                if (!refGraphMan.isButtonLineActivate()) {
                    selected = !selected;
                    refGraphMan.requestFocusMiddlePanel();
                }

                //Seleziona il panel
                if (selected) {
                    refGraphMan.refreshAliasPanel(id);
                    refGraphMan.clearSelectionMiddlePanel();
                    refGraphMan.showAliasPanel("Gate: " + id);
                    refGraphMan.showInfoGatePanels();
                    if(!refGraphMan.isCircuitStartedSimulate())
                        refGraphMan.setMenuEnabled(1, true);
                }

                if (linkIsAvailable(currentPin, typelink)) {
                    if ((refGraphMan.isInputTmpActivate() && !typelink)
                            ^ (refGraphMan.isGateTmpActivate() && refGraphMan.getGateTmpTypeLink() && !typelink)) {
	
                        refGraphMan.connect((JGatePanel) e.getSource());
                        linkinput.add(new LinkInput(setAndGetEffetiveLink(e.getPoint()), refGraphMan.getLastLinkShape(), currentPin));
                        refGraphMan.refreshMiddlePanel();
                    }

                    if ((refGraphMan.isOutputTmpActivate() && typelink)
                            ^ (refGraphMan.isGateTmpActivate() && !refGraphMan.getGateTmpTypeLink() && typelink)) {
      
						refGraphMan.connect((JGatePanel) e.getSource());
                        linkoutput.add(new LinkOutput(setAndGetEffetiveLink(e.getPoint()), refGraphMan.getLastLinkShape(), currentPin));
                        refGraphMan.refreshMiddlePanel();
                    }

                    if (refGraphMan.isButtonLineActivate() && !refGraphMan.isOutputTmpActivate()
                            && !refGraphMan.isGateTmpActivate() && !refGraphMan.isInputTmpActivate()) {
                        refGraphMan.setJLinkablePanelTmp((JGatePanel) e.getSource());
                        effetiveLink = setAndGetEffetiveLink(e.getPoint());
                        refGraphMan.refreshMiddlePanel();
                    }

                    if (refGraphMan.isSpotTmpActivate() && !refGraphMan.isInputTmpActivate() && !refGraphMan.isGateTmpActivate() && !typelink) {
						
						//effetiveLink = setAndGetEffetiveLink(e.getPoint());
						refGraphMan.connect((JGatePanel) e.getSource());
                        linkinput.add(new LinkInput(setAndGetEffetiveLink(e.getPoint()), refGraphMan.getLastLinkShape(), currentPin));
                        refGraphMan.refreshMiddlePanel();
                    }
                }

                repaint();
            }

            @Override
            public void mouseReleased(MouseEvent e) 
			{
                if (refGraphMan.moved) 
				{
                    if (isAboveLinkablePanel() || isOutOfWorkspace()) 
					{
                        ((Component) e.getSource()).setLocation(refGraphMan.tempComp);
                        refreshPositionLink();
						refGraphMan.refreshMiddlePanel();
                    }
                    refGraphMan.moved = false;
                }
                setCursor(new Cursor(Cursor.HAND_CURSOR));
            }
        });

        add(popupmenu);
        refresh();
    }
	
	public boolean isOutOfWorkspace()
	{
		if(getLocation().x < 50 || getLocation().y < 0)
		{
			return true;
		}
		return false;
	}	
	
    public void setId(int type, int _id) {
        id = _id;
        typegate = type;
        switch (typegate) {
            case Data.AND_GATE:
                ci = new char[2];
                co = new char[1];
                break;

            case Data.OR_GATE:
                ci = new char[2];
                co = new char[1];
                break;

            case Data.NAND_GATE:
                ci = new char[2];
                co = new char[1];
                break;

            case Data.NOR_GATE:
                ci = new char[2];
                co = new char[1];
                break;

            case Data.XOR_GATE:
                ci = new char[2];
                co = new char[1];
                break;

            case Data.NXOR_GATE:
                ci = new char[2];
                co = new char[1];
                break;

            case Data.NOT_GATE:
                ci = new char[1];
                co = new char[1];
                break;
        }
        for (int i = 0; i < ci.length; i++) {
            ci[i] = '0';
        }
        for (int i = 0; i < co.length; i++) {
            co[i] = '0';
        }

        setInputOutput();
    }

    @Override
    public void paintComponent(Graphics g) 
	{
        super.paintComponent(g);
        g.drawImage(background, 0, 0, null);
        g.setColor(Color.black);
        if (Startup.window.Split.MP.circuitsimulate && ci.length == 2) 
		{
            g.drawString(ci[0] + "", 0, Pin0_In_Y - 2);
            g.drawString(ci[1] + "", 0, Pin1_In_Y + 12);
            g.drawString(co[0] + "", getWidth() - 10, 18);
        }
		
        if (Startup.window.Split.MP.circuitsimulate && ci.length == 1) 
		{
            g.drawString(ci[0] + "", 0, 18);
            g.drawString(co[0] + "", getWidth() - 10, 18);
        }
    }
	
    //Un metodo che restituisce se non c'è il rischio di sovrappore i componenti figlio
    @Override
    public boolean isOptimizedDrawingEnabled() {
        return false;
    }

    //Settale coordinate dei punti di attacco dei link
    private void setInputOutput() 
	{		
        if(typegate == Data.NOT_GATE) 
		{
				coordInput[0] = new Point(0, PinMiddle_Coord);		
		}else{
                coordInput[0] = new Point(0, Pin0_In_Y);
                coordInput[1] = new Point(0, Pin1_In_Y);
		}
                coordOutput = new Point(background.getWidth(this), PinMiddle_Coord);
    }
	
    //Setta il punto dove fare il collegamento con coordiante assolute, facendo il confronto con quelle relative alla porta 
    @Override
    protected Point setAndGetEffetiveLink(Point p) 
	{
		//Gestisco separatamente i comportamenti per la porta NOT e le altre
        if(typegate != Data.NOT_GATE) 
		{
            if(p.x >= 0 && p.x < PinMiddle_Coord) 
			{
                if(p.y >= 0 && p.y < PinMiddle_Coord) 
				{
					/*
					System.out.println("Sono entrato qui perche'");
					System.out.println("p.x =" + p.x + " p.y =" + p.y);
					System.out.println("entrambi minori di " + PinMiddle_Coord);
					*/
                    typelink = Input;
                    currentPin = 0;
                    return new Point(coordInput[0].x + getX(), coordInput[0].y + getY());
                }else{
                    typelink = Input;
                    currentPin = 1;
                    return new Point(coordInput[1].x + getX(), coordInput[1].y + getY());
                }
            }else{
                typelink = Output;
                //currentPin = 0;
                return new Point(coordOutput.x + getX(), coordOutput.y + getY());
            }
        }else{
            if(p.x >= 0 && p.x < PinMiddle_Coord) 
			{
                typelink = Input;
                currentPin = 0;
                return new Point(coordInput[0].x + getX(), coordInput[0].y + getY());
            }else{
                typelink = Output;
                currentPin = 0;
                return new Point(coordOutput.x + getX(), coordOutput.y + getY());
            }
        }
    }
	
    @Override
    protected Point getEffettiveLink(int id, boolean typelink) 
	{
        // Typelink: se è vero è un output, se è falso è un input.
        if (!typelink) 
		{
            if (id != 1 && id != 0)	System.out.println("Errore JGatePanel 334");
            return new Point(coordInput[id].x + getX(), coordInput[id].y + getY());
        }
        return new Point(coordOutput.x + getX(), coordOutput.y + getY());
    }

    //Refresh delle coordinate dei link colegati alla porta
    public void refreshPositionLink() 
	{
        for (int i = 0; i < linkinput.size(); i++) 
		{
            if (linkinput.get(i) != null) 
			{
                linkinput.get(i).refresh(this, Input);
            }
        }
		
        for (int i = 0; i < linkoutput.size(); i++) 
		{
            if (linkoutput.get(i) != null) 
			{
                linkoutput.get(i).refresh(this, Output);
            }
        }
    }

    public boolean linkIsAvailable(int id, boolean linktype) 
	{
        if (linktype) 
		{
            for (int i = 0; i < linkoutput.size(); i++) 
			{
                if (linkoutput.get(i).getId() == id) {
                    return false;
                }
            }
        }else{
            for (int i = 0; i < linkinput.size(); i++) 
			{
                if (linkinput.get(i).getId() == id) {
                    return false;
                }
            }
        }
        return true;
    }

    //Si fa passare le coordinate del mouse
    public boolean isAboveLinkablePanel() {
        return refGraphMan.isAboveJLinkablePanel(this);
    }

    public void setValueGateInput(int ped, char value) {
        ci[ped] = value;
    }

    private PopupMenu createPopupMenuGatePanel() 
	{
        PopupMenu p = new PopupMenu();
        MenuItem item1 = new MenuItem("Disconnect");
        MenuItem item2 = new MenuItem("Delete");

        item1.addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) {
                refGraphMan.isolateJLinkablePanel(id, ((JGatePanel) ((PopupMenu) ((MenuItem) e.getSource()).getParent()).getParent()));
            }
        });

        item2.addActionListener(new ActionListener() 
		{
            @Override
            public void actionPerformed(ActionEvent e) {
                refGraphMan.searchDeleteSelected();
            }
        });

        p.add(item1);
        p.add(item2);

        return p;
    }
}
