package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import javax.swing.*;

/*
 * Nella classe è presente una variabile booleana per indicare che tipo di linkaggio 
 * si sta facendo se con un input o con un output, questo è stato possibile creando delle variabili
 * statiche final accessibili solo dalle classi figlie che possono settare di conseguenza il valore di "typelink".
 * In "currentPin" viene messo il numero del link che per convensione si inizia a contare dalla parte superiore sinistra nel
 * caso degli input, in quella superiore destra nel caso di output, di un JLinkablePanel.
 * Infine vengono adoperate due liste dinamiche per tenere conto dei reference ai link nel caso di un' 
 * eventuale cancellazione del JLinkablePanel così da chiamare la cancellazione dei medesimi link che sono coleggati
 * ad essa.
 */
public abstract class JLinkablePanel extends JPanel 
{
    public boolean out;
    public Image background;
    public char[] ci;
    public char[] co;
    protected Point effetiveLink;
    protected final static boolean Input = false;
    protected final static boolean Output = true;
    protected boolean typelink;
    protected int currentPin;
    protected boolean effaceable;
    public boolean selected = false;
	//Salvo i punti di ingresso e uscita di una porta
    protected Point[] coordInput;
    protected Point coordOutput;
	
    protected ArrayList<LinkInput> linkinput = new ArrayList();
    protected ArrayList<LinkOutput> linkoutput = new ArrayList();
    protected Point cornerupleft, cornerupright, cornerdownleft, cornerdownright;
    protected int id;
    
    GraphicsManager refGraphMan = Startup.window.graphMan;

    public JLinkablePanel() {
        cornerupleft = new Point(getX(), getY());
        cornerupright = new Point(getX() + getWidth(), getY());
        cornerdownleft = new Point(getX(), getY() + getHeight());
        cornerdownright = new Point(getX() + getWidth(), getY() + getHeight());
        setOpaque(false);
        setBackground(new Color(200, 200, 200));

        addMouseListener(new MouseAdapter() {

            @Override
            public void mouseEntered(MouseEvent e) {
                out = false;
            }

            @Override
            public void mouseExited(MouseEvent e) {
                out = true;
            }
        });

        refresh();
    }

    public Point getEffettiveLink() {
        return effetiveLink;
    }

    protected abstract Point getEffettiveLink(int id, boolean typelink);

    protected abstract Point setAndGetEffetiveLink(Point p);

    private void refreshCorner() {
        cornerupleft = new Point(getX(), getY());
        cornerupright = new Point(getX() + getWidth(), getY());
        cornerdownleft = new Point(getX(), getY() + getHeight());
        cornerdownright = new Point(getX() + getWidth(), getY() + getHeight());
    }

    public int getId() {
        return id;
    }

    public void refresh() {
        refreshCorner();
        revalidate();
        repaint();
    }
}
