package LCE.view;

import LCE.*;

import java.awt.*;
import java.awt.Point;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;
import javax.swing.OverlayLayout;
import javax.swing.SwingUtilities;

public class JSpotPanel extends JLinkablePanel 
{

    public JSpotPanel(Image _img, Point p, LinkShape s, int _id) 
	{
        //Setup del puntino, setto a 0 per collegare il primo link che avra' id 
        id = _id;
        background = _img;
        effetiveLink = p;
        currentPin = 0;
        setLocation(p.x - 4, p.y - 3);
        setPreferredSize(new Dimension(background.getWidth(this), background.getHeight(this)));
        setCursor(new Cursor(Cursor.HAND_CURSOR));

        //Mi salvo la vecchia linea
        LinkShape oldLine = s;

		//oldLine.outputgate.currentPin;
		
		//La elimino graficamente e dal model e i riferimenti dell'inputgate/outputgate
        refGraphMan.deleteLinkShape(s);    
		
        //Creo due linee temporanee nel Model
        int tmp1ID = refGraphMan.createLinkInModel(oldLine.inputgate.id, id, oldLine.pinI, 0);
        int tmp2ID = refGraphMan.createLinkInModel(id, oldLine.outputgate.id, 0, oldLine.pinO);
		
		//if(tmp1ID == -1 || tmp2ID == -1) System.out.println("Non sta funzionando, tmp1ID:"+tmp1ID+" tmp2ID:"+tmp2ID);
		
		if(s.inputgate instanceof JSpotPanel)
		{
		  //Setto il currentPin nel caso di spot collegati
		  oldLine.inputgate.currentPin = oldLine.pinI;
		}
		if(s.outputgate instanceof JSpotPanel)
		{
		  oldLine.outputgate.currentPin = oldLine.pinO;
		} 
				
	
		//Creo due linee temporanee graficamente
        LinkShape tmp1 = new LinkShape(oldLine.inputgate, this, tmp1ID);
        LinkShape tmp2 = new LinkShape(this, oldLine.outputgate, tmp2ID);

        //Setto i nuovi riferimenti dell'inputate/outputgate
        oldLine.inputgate.linkoutput.add(new LinkOutput(oldLine.p1, tmp1, oldLine.pinI));
        oldLine.outputgate.linkinput.add(new LinkInput(oldLine.p2, tmp2, oldLine.pinO));

        //Setto 2 dei riferimenti dello spot "Il terzo riferimento verrà settato nel connect del middlepanel
        linkinput.add(new LinkInput(effetiveLink, tmp1, 0));
        linkoutput.add(new LinkOutput(effetiveLink, tmp2, 0));
		
		
        //Aggiungo le 2 linee create al panel
        refGraphMan.addLinkShapeInMiddlePanel(tmp1);
        refGraphMan.addLinkShapeInMiddlePanel(tmp2);
		
        //Creo un ascoltatore per trascinare gli elementi
        addMouseMotionListener(new MouseMotionAdapter() 
		{
            Component c;
			//Serve per trascinare la JLabel dove vuoi
            @Override
            public void mouseDragged(MouseEvent e) 
			{
                if (refGraphMan.moved == false) 
				{    
                    refGraphMan.moved = true;
                    refGraphMan.tempComp = ((Component) e.getSource()).getLocation();   
                    //Mi salvo gli offset di dove ha premuto per la prima volta sul Panel.
                    refGraphMan.tempX = e.getX();
                    refGraphMan.tempY = e.getY();
                }else{           
                    refGraphMan.tempPointDrag = e.getPoint();   
                    if (SwingUtilities.isLeftMouseButton(e) && !refGraphMan.isCircuitStartedSimulate()) 
					{
                        setCursor(new Cursor(Cursor.MOVE_CURSOR));
                        if (refGraphMan.isComponentDraggable()) 
						{
                            c = e.getComponent();
                            if (!refGraphMan.isOnScreenOfMiddlePanel((JSpotPanel) c)) {
                                c.setLocation(c.getX() + e.getX() / 50, c.getY() + e.getY() / 50);
                            } else {
                                //Sottraggo l'offset in modo tale da eliminare il fastidioso effetto "scatto"
                                c.setLocation(c.getX() + e.getX() - refGraphMan.tempX, c.getY() + e.getY() - refGraphMan.tempY);
                            }
                            refGraphMan.setPositionGateInModel(id, (JLinkablePanel)c);
                            refreshPositionLink();
                            refresh();
                            refGraphMan.refreshMiddlePanel((JSpotPanel) e.getSource(), e);
                        }
                    }
                }
            }

            @Override
            public void mouseMoved(MouseEvent e) {
                repaint();
            }
        });
		addMouseListener(new MouseAdapter() {

			@Override
			public void mouseClicked(MouseEvent e) {
				super.mouseClicked(e);
				printLink();
			}
			
			@Override
            public void mouseReleased(MouseEvent e) 
			{
                if (refGraphMan.moved) 
				{
                    if (isAboveLinkablePanel() || isOutOfWorkspace()) 
					{
                        ((Component) e.getSource()).setLocation(refGraphMan.tempComp);
                        refreshPositionLink();
						refGraphMan.refreshMiddlePanel();
                    }
                    refGraphMan.moved = false;
                }
                setCursor(new Cursor(Cursor.HAND_CURSOR));
            }
		});
    }
	
	public boolean isOutOfWorkspace()
	{
		if(getLocation().x < 50 || getLocation().y < 0)
		{
			return true;
		}
		return false;
	}	
	
	public boolean isAboveLinkablePanel() {
        return refGraphMan.isAboveJLinkablePanel(this);
    }
    //Refresh delle coordinate dei link colegati allo spot
    public void refreshPositionLink() 
	{
        for (int i = 0; i < linkinput.size(); i++) 
		{
            if (linkinput.get(i) != null) 
			{
                linkinput.get(i).refresh(this, Input);
            }
        }
		
        for (int i = 0; i < linkoutput.size(); i++) 
		{
            if (linkoutput.get(i) != null) 
			{
                linkoutput.get(i).refresh(this, Output);
            }
        }
    }
	
	public void printLink(){
        int idline;
        int pinI;
        int pinO;
        int gateO;
        int gateI;
        for(int i = 0; i < linkinput.size(); i++){
            idline = linkinput.get(i).line.id;
            pinI = linkinput.get(i).line.pinI;
            pinO = linkinput.get(i).line.pinI;
            gateO = linkinput.get(i).line.outputgate.id;
            gateI = linkinput.get(i).line.inputgate.id;
            System.out.println("linkinput id: " + idline + ", pinI: " + pinI + ", pinO: " + pinO + ". ID_gateI: " + gateI + " ID_gateO: " + gateO);
        }
        
        for(int i = 0; i < linkoutput.size(); i++){
            idline = linkoutput.get(i).line.id;
            pinI = linkoutput.get(i).line.pinI;
            pinO = linkoutput.get(i).line.pinI;
            gateO = linkoutput.get(i).line.outputgate.id;
            gateI = linkoutput.get(i).line.inputgate.id;
            System.out.println("linkoutput id: " + idline + ", pinI: " + pinI + ", pinO: " + pinO + ". ID_gateI: " + gateI + " ID_gateO: " + gateO);
        }
		System.out.println();
    }
	
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(background, 0, 0, this);
    }

    @Override
    protected Point getEffettiveLink(int id, boolean typelink) {
        effetiveLink = new Point(getX()+2, getY()+2);
        return effetiveLink;
    }

    @Override
    protected Point setAndGetEffetiveLink(Point p) {
        effetiveLink = getEffettiveLink();
        return effetiveLink;
    }
}
