package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.event.ComponentEvent;
import java.net.URL;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentListener;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class SouthPanel extends JPanel {

    JTextField Input;
    JTextField Output;
    JTextArea listcomponent;
    JScrollPane listcomponentScrollPane;
    JLabel Jlbl1;
    JLabel Jlbl2;
    JSpinner Jspin1;
    JSpinner Jspin2;
    JButton JButt1;
    SpinnerNumberModel model1;
    SpinnerNumberModel model2;
    InfoGatePanels IGP;
    URL urlIMG = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/refresh.gif");
    GraphicsManager refGraphMan;

    public SouthPanel() {

        setLayout(null);
        setMinimumSize(new Dimension(0, 100));
        IGP = new InfoGatePanels();

        //Creo il model per gli spinner
        model1 = new SpinnerNumberModel(0, 0, 1000, 1);
        model2 = new SpinnerNumberModel(0, 0, 1000, 1);

        //Prima Etichetta
        Jlbl1 = new JLabel("Num. IN:");
        Jlbl1.setSize(100, 30);
        Jlbl1.setLocation(10, 15);
        Jlbl1.setLabelFor(Jspin1);

        Jspin1 = new JSpinner(model1);
        Jspin1.setBounds(120, 20, 50, 20);
        Jspin1.addChangeListener(new InputChangeListener(Jspin1));

        //Seconda Etichetta
        Jlbl2 = new JLabel("Num. LED:");
        Jlbl2.setSize(100, 30);
        Jlbl2.setLocation(10, 50);
        Jlbl2.setLabelFor(Output);

        Jspin2 = new JSpinner(model2);
        Jspin2.setBounds(120, 60, 50, 20);
        Jspin2.addChangeListener(new OutputChangeListener(Jspin2));

        listcomponent = new JTextArea();
        listcomponent.setEditable(false);
        listcomponentScrollPane = new JScrollPane(listcomponent);
        listcomponentScrollPane.setBounds(180, 0, 200, 100);

        JButt1 = new JButton(new ImageIcon(urlIMG));
        JButt1.setBounds(380, 80, 20, 20);
        JButt1.setCursor(new Cursor(Cursor.HAND_CURSOR));
        JButt1.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                listcomponent.setText(refGraphMan.getListDebug());
            }
        });

        addComponentListener(new SouthPanelComponentListener());

        add(Jlbl1);
        add(Jlbl2);
        add(Jspin1);
        add(Jspin2);
        add(IGP);
        add(listcomponentScrollPane);
        add(JButt1);
    }

    public void createLinkableInfo(JLinkablePanel JLP) {
        IGP.addCard(JLP);
    }

    public void deleteLinkableInfo(JLinkablePanel JLP) {
        IGP.remove(JLP);
    }

    public void disableComponents() {
        for (int i = 0; i < getComponentCount(); i++) {
            getComponent(i).setEnabled(false);
        }
        for (int i = 0; i < IGP.getComponentCount(); i++) {
            InfoGatePanel tmp = ((InfoGatePanel) (IGP.getComponent(i)));
            for (int j = 0; j < tmp.getComponentCount(); j++) {
                if (tmp.getComponent(j) instanceof InputGatePanel) {
                    InputGatePanel tmp2 = (InputGatePanel) tmp.getComponent(j);
                    for (int k = 0; k < tmp2.getComponentCount(); k++) {
                        tmp2.getComponent(k).setEnabled(false);
                    }
                    tmp.getComponent(j).setEnabled(false);
                }
            }
        }
    }

    public void enableComponents() {
        for (int i = 0; i < getComponentCount(); i++) {
            getComponent(i).setEnabled(true);
        }
        for (int i = 0; i < IGP.getComponentCount(); i++) {
            InfoGatePanel tmp = ((InfoGatePanel) (IGP.getComponent(i)));
            for (int j = 0; j < tmp.getComponentCount(); j++) {
                if (tmp.getComponent(j) instanceof InputGatePanel) {
                    InputGatePanel tmp2 = (InputGatePanel) tmp.getComponent(j);
                    for (int k = 0; k < tmp2.getComponentCount(); k++) {
                        tmp2.getComponent(k).setEnabled(true);
                    }
                    tmp.getComponent(j).setEnabled(true);
                }
            }
        }
    }

    public void initializesRefGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }
    
    public void reset(){
        refGraphMan.hideInfoGatePanels();
        IGP.removeAll();
        Jspin1.setValue(0);
        Jspin2.setValue(0);
    }
}

class InputChangeListener implements ChangeListener {

    JSpinner Jspin1;

    public InputChangeListener(JSpinner j) {
        Jspin1 = j;
    }

    @Override
    public void stateChanged(ChangeEvent e) {
        int n = Integer.parseInt(Jspin1.getValue().toString());
        GraphicsManager ref = ((SouthPanel) ((JSpinner) e.getSource()).getParent()).refGraphMan;
        ref.setInputPanelInMiddlePanel(n);
        ref.clearSelectionMiddlePanel();
        ref.refreshMiddlePanel();
        ref.hideInfoGatePanels();
    }
}

class OutputChangeListener implements ChangeListener {

    JSpinner Jspin2;

    public OutputChangeListener(JSpinner j) {
        Jspin2 = j;
    }

    @Override
    public void stateChanged(ChangeEvent e) {
        int n = Integer.parseInt(Jspin2.getValue().toString());
        GraphicsManager ref = ((SouthPanel) ((JSpinner) e.getSource()).getParent()).refGraphMan;
        ref.setLedPanelInMiddlePanel(n);
        ref.clearSelectionMiddlePanel();
        ref.refreshMiddlePanel();
        ref.hideInfoGatePanels();
    }
}

class SouthPanelComponentListener implements ComponentListener {

    @Override
    public void componentResized(ComponentEvent e) {
        if (e.getSource() instanceof SouthPanel) {
            ((SouthPanel) e.getSource()).listcomponentScrollPane.setSize(200, ((SouthPanel) e.getSource()).getHeight());
        }
    }

    @Override
    public void componentMoved(ComponentEvent e) {
    }

    @Override
    public void componentShown(ComponentEvent e) {
    }

    @Override
    public void componentHidden(ComponentEvent e) {
    }
}
