package LCE.controller;

import LCE.*;
import LCE.model.*;

public class Core {
    //Salvo un riferimento ai dati

    Data refDati;

    public Core() {
        //Inizializzo i dati
        refDati = Startup.data = new Data();
    }

    public int createPiece(int tipo, int x, int y) {
        return refDati.circuito.insertPiece(tipo, x, y);
    }

    public void deletePiece(int id) {
        refDati.circuito.isolateGate(id);
        refDati.circuito.deletePiece(id);
    }

    public int createLink(int idI, int idO, int piedinoI, int piedinoO) {
        return refDati.circuito.insertLink(idI, idO, piedinoI, piedinoO);
    }

    public void deleteLink(int id) {
        refDati.circuito.deleteLink(id);
    }

    public int insertInput() {
        return refDati.circuito.addInput();
    }

    public void deleteInput(int idInput) {
        refDati.circuito.deleteInput(idInput);
    }

    public int insertLed() {
        return refDati.circuito.addOutput();
    }

    public void deleteOutput(int idOutput) {
        refDati.circuito.deleteOutput(idOutput);
    }

    public boolean getInputValue(int idPiece, int idPed) {
        return refDati.circuito.getInputOfPiece(idPiece, idPed);
    }

    public boolean getOutputValueOfPiece(int idPiece, int idPed) {
        return refDati.circuito.getOutputOfPiece(idPiece, idPed);
    }

    public void isolatePiece(int idPiece) {
        if (refDati.circuito.searchOutput(idPiece) != null) {
            refDati.circuito.isolateOutput(idPiece);
        } else {
            if (refDati.circuito.searchInput(idPiece) != null) {
                refDati.circuito.isolateInput(idPiece);
            } else {
                refDati.circuito.isolateGate(idPiece);
            }
        }
    }

    public void setNameOfInput(int idInput, String s) {
        Input t = refDati.circuito.searchInput(idInput);
        if (t == null) {
            return;
        }
        t.setName(s);
    }

    public String getNameOfInput(int idInput) {
        Input t = refDati.circuito.searchInput(idInput);
        if (t == null) {
            return "";
        }
        return t.getName();
    }

    public void setInputValueOfPiece(int idIn, boolean value, int idGate) {
        refDati.circuito.setInputOfGate(idIn, value, idGate);
    }

    public boolean getInputValueOfPiece(int idPiece, int idIn) {
        return refDati.circuito.getInputOfPiece(idPiece, idIn);
    }

    public void setInputValue(int idPiece, boolean value) {
        refDati.circuito.setInput(idPiece, value);
    }

    public String printListPieces() {
        return refDati.circuito.StampaPieces();
    }

    public String printListLine() {
        return refDati.circuito.StampaLine();
    }

    public boolean startSimulate() {
        refDati.circuito.refreshCircuit();
        return true;
    }

    public boolean stopSimulate() {
        return true;
    }

    public void refreshDate() {
        refDati.circuito.refreshCircuit();
    }

    public void setOutputValue(int idLed, boolean value) {
        refDati.circuito.setLed(idLed, value);
    }

    public void setPositionOfGate(int idGate, int x, int y) {
        refDati.circuito.setGatePosition(idGate, x, y);
    }
    
    public void resetCircuit(){
        refDati.reset();
    }
}