package LCE.view;

import LCE.*;
import java.awt.CardLayout;
import java.awt.Cursor;
import java.awt.Image;
import java.awt.MenuBar;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.net.URL;
import javax.swing.JMenuBar;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.JViewport;

public class GraphicsManager {

    GUI gui;
    ToolGateBar TGB;
    MiddlePanel MP;
    SouthPanel SP;
    InfoGatePanels IGP;
    JSplitPane JSP;
    JMenuBar MB;
    public Point tempComp;
    public Point tempPointDrag;
    public boolean moved;
    public int selectedComp;
    public int tempX;
    public int tempY;

    public GraphicsManager(GUI g) {
        gui = g;
        TGB = (ToolGateBar) g.Tool;
        MB = g.Menu;
    }

    public void initializesSplitComponents(GUI g) {
        MP = g.Split.MP;
        SP = g.Split.SP;
        IGP = g.Split.SP.IGP;
        JSP = g.Split;
    }

    public void hideInfoGatePanels() {
        Startup.window.Split.SP.IGP.setVisible(false);
    }

    public void showInfoGatePanels() {
        Startup.window.Split.SP.IGP.setVisible(true);
    }

    public void createLinkableInfo(JLinkablePanel JLP) {
        Startup.window.Split.SP.createLinkableInfo(JLP);
    }

    public void refreshMiddlePanel() {
        MP.refresh();
        refreshValue();
    }

    public void refreshValue() {
        Startup.core.refreshDate();
        MP.refreshValueGate();
        MP.refreshValueOutput();
        MP.revalidate();
        MP.repaint();
    }

    public void refreshMiddlePanel(JLinkablePanel JLP, MouseEvent e) {
        MP.refresh(JLP, e);
    }

    public void refreshAliasPanel(int id) {
        IGP.searchAliasPanel(id).refresh();
    }

    public InfoGatePanel searchAliasPanel(int id) {
        return IGP.searchAliasPanel(id);
    }

    public void clearSelectionToolBar() {
        TGB.clearSelection();
    }

    public void clearSelectionMiddlePanel() {
        MP.clearSelection();
    }

    public void buttonSelectedToolBar() {
        TGB.selectedButton();
    }

    public void setSelectedJLinkablePanel(int id) {
        selectedComp = id;
    }

    public int getSelectedJLinkablePanel() {
        return selectedComp;
    }

    public int createGateOrSpotInModel(int tipo, int x, int y) {
        return Startup.core.createPiece(tipo, x, y);
    }

    public void setTextInputPanel(int id, ActionEvent e, InfoGatePanel IGP) {
        Startup.core.setNameOfInput(id, ((JTextField) e.getSource()).getText());
        for (int i = 0; i < MP.getComponentCount(); i++) {
            if (MP.getComponent(i) instanceof InputPanel
                    && ((InputPanel) MP.getComponent(i)).id == IGP.JLP.id) {
                ((InputPanel) MP.getComponent(i)).textlabel.setText(((JTextField) e.getSource()).getText());
            }
        }
    }

    public void setInputInModel(int id, boolean value) {
        Startup.core.setInputValue(id, value);
    }

    public void setOutputInModel(int id, boolean value) {
        Startup.core.setOutputValue(id, value);
    }

    public void setValueGateInModel(int ped, boolean value, int id) {
        Startup.core.setInputValueOfPiece(ped, value, id);
    }

    public void requestFocusMiddlePanel() {
        MP.requestFocus();
    }

    public void showAliasPanel(String str) {
        ((CardLayout) IGP.getLayout()).show(IGP, str);
    }

    //Metodi che controllano se sono attivati pulsanti nella tooolbar
    public boolean isButtonLineActivate() {
        return MP.butlineact;
    }

    //Attiva i pulsanti della toolbar
    public void activateLineButton() {
        MP.butlineact = true;
    }

    public void activateGateButton() {
        MP.butgateact = true;
    }

    public void activateSpotbutton() {
        MP.butspotact = true;
    }

    public void activateRubberButton() {
        MP.butrubber = true;
    }
    //

    //Disattiva i pulsatni della toolbar
    public void offLineButton() {
        MP.butlineact = false;
    }

    public void offGateButton() {
        MP.butgateact = false;
    }

    public void offRubberButton() {
        MP.butrubber = false;
    }
    //

    //Metodi per verificare se non ci sono altri JLinkablePanel temporanei attivati
    public boolean isGateTmpActivate() {
        return MP.gatetmp != null;
    }

    public boolean isInputTmpActivate() {
        return MP.inputtmp != null;
    }

    public boolean isOutputTmpActivate() {
        return MP.outputtmp != null;
    }

    public boolean isSpotTmpActivate() {
        return MP.spottmp;
    }

    //Metodo che settano i JLinkablePanel temporanei
    public void setJLinkablePanelTmp(JLinkablePanel JLP) {
        if (JLP instanceof JGatePanel) {
            MP.gatetmp = (JGatePanel) JLP;
        }
        if (JLP instanceof InputPanel) {
            MP.inputtmp = (InputPanel) JLP;
        }
        if (JLP instanceof LedPanel) {
            MP.outputtmp = (LedPanel) JLP;
        }
    }

    public void connect(JLinkablePanel JLP) {
        MP.connect(JLP);
    }

    public URL getURLResource(String str) {
        return Startup.class.getClassLoader().getResource(Startup.pathMain + str);
    }

    public void isolateJLinkablePanel(int id, JLinkablePanel JLP) {
        Startup.core.isolatePiece(id);
        MP.isolateLinkablePanel(JLP);
    }

    public LinkShape getLastLinkShape() {
        return MP.lastlineshape;
    }

    public void setImgGateTmp(Image i, int id) {
        MP.setImageGateTmp(i, id);
    }

    public void setImgSpotTmp(Image i) {
        MP.imgspottmp = i;
    }

    public boolean isCircuitStartedSimulate() {
        return MP.circuitsimulate;
    }

    public boolean isComponentDraggable() {
        return MP.componentdraggable;
    }

    public void setComponentDraggable(boolean value) {
        MP.componentdraggable = value;
    }

    public void setCircuitSimulate(boolean value) {
        MP.circuitsimulate = value;
    }

    public boolean isOnScreenOfMiddlePanel(JLinkablePanel JLP) {
        return Startup.window.Split.onScreenOfMiddlePanel(JLP);
    }

    public void setPositionGateInModel(int id, JLinkablePanel JLP) {
        Startup.core.setPositionOfGate(id, JLP.getX(), JLP.getY());
    }

    public void setMenuEnabled(int i, boolean value) {
        MB.getMenu(i).setEnabled(value);
    }

    public boolean getGateTmpTypeLink() {
        return MP.gatetmp.typelink;
    }

    public void searchDeleteSelected() {
        MP.searchDeleteSelected();
    }

    public boolean isAboveJLinkablePanel(JLinkablePanel JLP) {
        return MP.isAboveJLinkablePanel(JLP);
    }

    public boolean stopSimulate() {
        return Startup.core.stopSimulate();
    }

    public boolean startSimulate() {
        return Startup.core.startSimulate();
    }

    public void enableSplitPanelAndToolGateBar() {
        MP.enableComponents();
        SP.enableComponents();
        TGB.enableToolBar();
    }

    public void disableSplitPanelAndToolGateBar() {
        MP.disableComponents();
        SP.disableComponents();
        TGB.disableToolBar();
    }

    public void optimizesSpace() {
        MP.optimizesSpace();
    }

    public void setCursor(Cursor c) {
        MP.setCursor(c);
    }

    public void deleteLinkShape(LinkShape s) {
        MP.deleteLinkShape(s);
    }

    public int createLinkInModel(int idI, int idO, int piedinoI, int piedinoO) {
        return Startup.core.createLink(idI, idO, piedinoI, piedinoO);
    }

    public void addLinkShapeInMiddlePanel(LinkShape s) {
        MP.shapes.add(s);
    }

    public String getListDebug() {
        return Startup.core.printListLine() + Startup.core.printListPieces();
    }

    //Setta gli Input nel MiddlePanel
    public void setInputPanelInMiddlePanel(int n) {
        MP.setInputPanel(n);
    }

    //Setta gli Output nel MiddlePanel
    public void setLedPanelInMiddlePanel(int n) {
        MP.setLedPanel(n);
    }

    public JLinkablePanel searchJLinkablPanel(int id) {
        for (int i = 0; i < MP.getComponentCount(); i++) {
            if (MP.getComponent(i) instanceof JLinkablePanel && ((JLinkablePanel) MP.getComponent(i)).id == id) {
                return (JLinkablePanel) MP.getComponent(i);
            }
        }
        return null;
    }

    public void deleteGateInModel(int id) {
        Startup.core.deletePiece(id);
    }

    public void deleteOutputInModel(int id) {
        Startup.core.deleteOutput(id);
    }

    public void deleteInputInModel(int id) {
        Startup.core.deleteInput(id);
    }

    public void deleteLinkableInfo(JLinkablePanel JLP) {
        SP.deleteLinkableInfo(JLP);
    }

    public boolean isOutMouse() {
        return MP.out;
    }

    public void mySetJViewport(Point p, JLinkablePanel JLP) {
        gui.Split.mySetJViewport(MP, p, JLP);
    }

    public void setNameOfInput(ActionEvent e, int idInput, String s) {
        Startup.core.setNameOfInput(idInput, s);
        IGP.setNameOfInput(e);
    }

    public int insertInput() {
        return Startup.core.insertInput();
    }

    public int insertOutput() {
        return Startup.core.insertLed();
    }

    public JViewport getViewPortMiddlePanel() {
        return gui.Split.j.getViewport();
    }

    public boolean getValueJLinkablePanelInput(JLinkablePanel JGP, int pedI) {
        return Startup.core.getInputValueOfPiece(JGP.id, pedI);
    }

    public boolean getValueJLinkablePanelOutput(JLinkablePanel JGP, int pedO) {
        return Startup.core.getOutputValueOfPiece(JGP.id, pedO);
    }

    public void disableButtonTmpMiddlePanel() {
        MP.disableButtonTmpMiddlePanel();
    }
    
    public void resetCircuit(){
        Startup.core.resetCircuit();
        MP.reset();
        SP.reset();
    }
}
