package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.border.BevelBorder;

//Pannello inferiore con informazioni sul componente selezionato.
public class InfoGatePanels extends JPanel {

    public InfoGatePanels() 
	{
        setBounds(400, 0, 390, 100);
        setLayout(new CardLayout());
    }

    //Aggiunge un panel al CardLayout
    public void addCard(JLinkablePanel JLP) 
	{
        String str = "";
        if (JLP instanceof JGatePanel) str = "Gate";
        if (JLP instanceof InputPanel) str = "Input";
        if (JLP instanceof LedPanel) str = "Output";
        InfoGatePanel IGP = new InfoGatePanel(JLP);
        IGP.setName(str + ": " + JLP.getId());
        add(IGP, IGP.getName());
    }

    public InfoGatePanel searchAliasPanel(int id) 
	{
        for (int i = 0; i < getComponentCount(); i++) 
		{
            if (((InfoGatePanel) getComponent(i)).JLP.id == id) 
			{
                return ((InfoGatePanel) getComponent(i));
            }
        }
        return null;
    }

    public void setNameOfInput(ActionEvent e) {
        for (int i = 0; i < getComponentCount(); i++) {
            if (((InfoGatePanel) getComponent(i)).JLP.id == ((MYJTextField) e.getSource()).idinput) {
                ((InfoGatePanel) getComponent(i)).setTextImagePanel(((JTextField) e.getSource()).getText());
            }
        }
    }
}

//Singolo componente del pannello inferiore info
class InfoGatePanel extends JPanel {

    public JLinkablePanel JLP;
    private ImageGatePanel Imgp;
    private InputGatePanel Ingp;
    private OutputGatePanel Ougp;

    public InfoGatePanel(JLinkablePanel _JLP) {
        JLP = _JLP;
        setPreferredSize(new Dimension(400, 100));

        if (JLP instanceof JGatePanel) {
            setLayout(new GridLayout(1, 3));
            Imgp = new ImageGatePanel(JLP.background, "" + JLP.getId(), getType(((JGatePanel) JLP).typegate));
            Ingp = new InputGatePanel(JLP.ci);
            Ougp = new OutputGatePanel(JLP.co);
            add(Imgp);
            add(Ingp);
            add(Ougp);
        }

        if (JLP instanceof InputPanel) {
            setLayout(new GridLayout(1, 2));
            Imgp = new ImageGatePanel(JLP.background, "" + JLP.getId(), "Input", ((InputPanel) JLP).textlabel.getText());
            Ougp = new OutputGatePanel(JLP.co);
            add(Imgp);
            add(Ougp);
        }

        if (JLP instanceof LedPanel) {
            setLayout(new GridLayout(1, 2));
            Imgp = new ImageGatePanel(JLP.background, "" + JLP.getId(), "Output");
            Ingp = new InputGatePanel(JLP.ci);
            add(Imgp);
            add(Ingp);
        }
    }

    public String getType(int type) 
	{
        String tmp_stringa = "";
        switch(type) 
		{
            case Data.AND_GATE:
                tmp_stringa = "AND";
                break;
            case Data.OR_GATE:
                tmp_stringa = "OR";
                break;
            case Data.NAND_GATE:
                tmp_stringa = "NAND";
                break;
            case Data.NOR_GATE:
                tmp_stringa = "NOR";
                break;
            case Data.XOR_GATE:
                tmp_stringa = "XOR";
                break;
            case Data.NXOR_GATE:
                tmp_stringa = "NXOR";
                break;
            case Data.NOT_GATE:
                tmp_stringa = "NOT";
                break;
        }
        return tmp_stringa + " Gate";
    }

    public void setTextImagePanel(String s) {
        Imgp.JTxt.setText(s);
    }

    public void refresh() 
	{
        if (Imgp != null) Imgp.refresh(JLP);
        if (Ingp != null) Ingp.refresh(JLP);
        if (Ougp != null) Ougp.refresh(JLP);
    }
}

class ImageGatePanel extends JPanel 
{

    private Image img;
    private String strID;
    private JLabel JLbl;
    JTextField JTxt;
    private String type;
    GraphicsManager refGraphMan = Startup.window.graphMan;

    public ImageGatePanel(Image _img, String id, String type) 
	{
        setLayout(new BorderLayout());
        img = _img;
        strID = id;
        this.type = type;
        JLbl = new JLabel("      " + type + " Id: " + strID);
        add(JLbl, BorderLayout.NORTH);
        setBorder(new BevelBorder(BevelBorder.LOWERED));
        setOpaque(false);
        repaint();
    }

    public ImageGatePanel(Image _img, String _id, String _type, String s) {
        setLayout(new BorderLayout());
        img = _img;
        strID = _id;
        type = _type;
        JLbl = new JLabel(type + " Id: " + strID);
        JTxt = new JTextField(s);
        JTxt.setSize(new Dimension(20, 20));
        JTxt.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                refGraphMan.setTextInputPanel(Integer.parseInt(strID), e, (InfoGatePanel) getParent());
            }
        });
        add(JLbl, BorderLayout.PAGE_START);
        add(JTxt, BorderLayout.PAGE_END);
        setBorder(new BevelBorder(BevelBorder.LOWERED));
        setOpaque(false);
        repaint();
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.drawImage(img, (getWidth() - img.getWidth(this)) / 2, (getHeight() - img.getHeight(this)) / 2, this);
    }

    public void refresh(JLinkablePanel JLP) {
        img = JLP.background;
        if (JLP instanceof JGatePanel || 
			JLP instanceof InputPanel ||
			JLP instanceof LedPanel) 
				strID = JLP.id + "";
        JLbl.setText("      " + type + " Id: " + strID);
        repaint();
    }
}

class InputGatePanel extends JPanel {

    private JButton[] JButtvett;
    private JLabel JLbl;
    private int i = 0;

    public InputGatePanel(char[] c) {
        setLayout(new GridLayout(c.length + 1, 1));
        setBorder(new BevelBorder(BevelBorder.LOWERED));
        JButtvett = new JButton[c.length];
        JLbl = new JLabel("Input");
        JLbl.setFont(new Font(Font.DIALOG, Font.ITALIC, 20));
        JLbl.setHorizontalAlignment((int) CENTER_ALIGNMENT);
        add(JLbl);
        for (i = 0; i < c.length; i++) {
            JButtvett[i] = new JButton(c[i] + "");
            JButtvett[i].addActionListener(new ButtonInfoActionListener(i));
            JButtvett[i].setCursor(new Cursor(Cursor.HAND_CURSOR));
            add(JButtvett[i]);
        }
    }

    public void refresh(JLinkablePanel JLP) {
        for (int i = 0; i < JLP.ci.length; i++) {
            JButtvett[i].setText(JLP.ci[i] + "");
        }
    }
}

class OutputGatePanel extends JPanel {

    private JButton[] JButtvett;
    private JLabel JLbl;

    public OutputGatePanel(char[] c) 
	{
        setLayout(new GridLayout(c.length + 1, 1));
        setBorder(new BevelBorder(BevelBorder.LOWERED));
        JButtvett = new JButton[c.length];
        JLbl = new JLabel("Output");
        JLbl.setFont(new Font(Font.DIALOG, Font.ITALIC, 20));
        JLbl.setHorizontalAlignment((int) CENTER_ALIGNMENT);
        add(JLbl);
        for (int i = 0; i < c.length; i++) 
		{
            JButtvett[i] = new JButton(c[i] + "");
            JButtvett[i].setEnabled(false);
            add(JButtvett[i]);
        }
    }

    public void refresh(JLinkablePanel JLP) {
        for (int i = 0; i < JLP.co.length; i++) {
            JButtvett[i].setText(JLP.co[i] + "");
        }
    }
}

class ButtonInfoActionListener implements ActionListener {

    public int ped;
    GraphicsManager refGraphMan = Startup.window.graphMan;

    public ButtonInfoActionListener(int _ped) {
        ped = _ped;
    }

    @Override
    public void actionPerformed(ActionEvent e) 
	{
        InfoGatePanel inp = ((InfoGatePanel) ((InputGatePanel) ((JButton) e.getSource()).getParent()).getParent());
		
        if (((JButton) e.getSource()).getText().equalsIgnoreCase("0")) 
		{
            ((JButton) e.getSource()).setText("1");
            if (inp.JLP instanceof LedPanel) 
			{
                refGraphMan.setOutputInModel(inp.JLP.id, true);
                ((LedPanel) inp.JLP).setValueOutput(true);
                refGraphMan.refreshAliasPanel(inp.JLP.id);
            }
            if (inp.JLP instanceof JGatePanel) {
                ((JGatePanel) inp.JLP).setValueGateInput(ped, '1');
                refGraphMan.setValueGateInModel(ped, true, inp.JLP.id);
            }
        } else {
            ((JButton) e.getSource()).setText("0");
            if (inp.JLP instanceof LedPanel) 
			{
                refGraphMan.setOutputInModel(inp.JLP.id, false);
                ((LedPanel) inp.JLP).setValueOutput(false);
                refGraphMan.refreshAliasPanel(inp.JLP.id);
            }
            if (inp.JLP instanceof JGatePanel) {
                refGraphMan.setValueGateInModel(ped, false, inp.JLP.id);
                ((JGatePanel) inp.JLP).setValueGateInput(ped, '0');
            }
        }

        refGraphMan.refreshValue();
        inp.refresh();
    }
}