package LCE.view;

import LCE.*;
import LCE.controller.*;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.*;

public class JSpotButton extends JButton {

    Image img;
    Cursor custom;
    GraphicsManager refGraphMan;

    public JSpotButton(Image _img) {
        this(_img, "");
    }

    public JSpotButton(Image _img, String text) {
        super(text);
        img = _img;
        custom = Toolkit.getDefaultToolkit().createCustomCursor(Toolkit.getDefaultToolkit().getImage(Startup.class.getClassLoader().getResource(Startup.pathMain + "img/spotcursor.gif")), new Point(0, 0), "");
        setSize(40, 50);
        setIcon(new ImageIcon(img.getScaledInstance(36, 36, Image.SCALE_DEFAULT)));
        setDisabledIcon(new ImageIcon(img.getScaledInstance(36, 36, Image.SCALE_DEFAULT)));
        setBorder(null);
        setOpaque(false);
        setBackground(new Color(0, 150, 255));
        setCursor(new Cursor(Cursor.HAND_CURSOR));

        addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                if (getParent() instanceof ToolGateBar && !((ToolGateBar) getParent()).butselected) {
                    ((ToolGateBar) getParent()).butselected = true;
                    refGraphMan.activateSpotbutton();
                    refGraphMan.setImgSpotTmp(Toolkit.getDefaultToolkit().getImage(refGraphMan.getURLResource("img/spotbackground.gif")));
                    refGraphMan.setCursor(custom);
                    refGraphMan.setComponentDraggable(false);
                    setOpaque(true);
                }
            }
        });
    }
    
    public void initializesGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }
}
