package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.Point;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.util.*;

public class LinkShape extends MyShape {

    Point p1;
    Point p2;
    int pinI;
    int pinO;
    JLinkablePanel inputgate;
    JLinkablePanel outputgate;
    ArrayList<Point> pointOfPaint = new ArrayList<Point>();

    public LinkShape(InputPanel i, JLinkablePanel o, int id) {
        shape = new GeneralPath();
        p1 = i.effetiveLink;
        p2 = o.effetiveLink;
        pinI = i.currentPin;
        pinO = o.currentPin;
        inputgate = i;
        outputgate = o;
        this.id = id;
        makeShape();
    }

    public LinkShape(JLinkablePanel i, JLinkablePanel o, int id) {
        shape = new GeneralPath();
        p1 = i.effetiveLink;
        p2 = o.effetiveLink;
        pinI = i.currentPin;
        pinO = o.currentPin;
        inputgate = i;
        outputgate = o;
        this.id = id;
        makeShape();
    }

    public LinkShape(LedPanel i, JLinkablePanel o, int id) {
        shape = new GeneralPath();
        p1 = i.effetiveLink;
        p2 = o.effetiveLink;
        pinI = i.currentPin;
        pinO = o.currentPin;
        inputgate = i;
        outputgate = o;
        this.id = id;
        makeShape();
    }

    @Override
    public void makeShape() 
	{
        int incY = 0;
        int incX = 0;
        
        if(p1.y<p2.y)
            incY = -40;
        else
            incY = 40;
        
        if(pinO==1)
            incX = 10;
        else
            incX = 20;
            
        pointOfPaint.clear();
        
        /*
         * Carico i punti nel caso in cui come input della linea ci sia un JGatePanel
         * o un inputPanel
         */
        if(inputgate instanceof JGatePanel || inputgate instanceof InputPanel)
		{
            if(p1.x < p2.x){
                pointOfPaint.add(new Point(p1.x,p1.y));
                pointOfPaint.add(new Point(p1.x+incX,p1.y));
                 pointOfPaint.add(new Point(p2.x-incX,p1.y));
                 pointOfPaint.add(new Point(p2.x-incX,p2.y));
                 pointOfPaint.add(new Point(p2.x,p2.y));
            }else{
                 pointOfPaint.add(new Point(p1.x,p1.y));
                 pointOfPaint.add(new Point(p1.x+incX,p1.y));
                 pointOfPaint.add(new Point(p1.x+incX,p2.y+incY));
                 pointOfPaint.add(new Point(p2.x-incX,p2.y+incY));
                 pointOfPaint.add(new Point(p2.x-incX,p2.y));
                 pointOfPaint.add(new Point(p2.x,p2.y));
            }
        }
        
        /*
         * Carico i punti nel caso come input ci sia un JSpotPanel  
         */
        if(inputgate instanceof JSpotPanel && !(outputgate instanceof JSpotPanel))
		{
            if(pinI == 1)
			{
                if(p1.x < p2.x)
				{
                     pointOfPaint.add(new Point(p1.x,p1.y));
                     pointOfPaint.add(new Point(p1.x,p2.y));
                     pointOfPaint.add(new Point(p2.x,p2.y));
                }else{
                     pointOfPaint.add(new Point(p1.x,p1.y));
                     pointOfPaint.add(new Point(p1.x,p2.y+incY));
                     pointOfPaint.add(new Point(p2.x-incX,p2.y+incY));
                     pointOfPaint.add(new Point(p2.x-incX,p2.y));
                     pointOfPaint.add(new Point(p2.x,p2.y));
                }
            }else{
                if(p1.x<p2.x)
				{
                     pointOfPaint.add(new Point(p1.x, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p2.y));
                     pointOfPaint.add(new Point(p2.x, p2.y));
                }else{
                     pointOfPaint.add(new Point(p1.x, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p2.y + incY));
                     pointOfPaint.add(new Point(p2.x-incX, p2.y + incY));
                     pointOfPaint.add(new Point(p2.x-incX, p2.y));
                     pointOfPaint.add(new Point(p2.x, p2.y));
                }
            }
        } 
        
        if(inputgate instanceof JSpotPanel && outputgate instanceof JSpotPanel)
		{
            if(pinI == 1)
			{
                if(p1.x<p2.x)
				{
                     pointOfPaint.add(new Point(p1.x,p1.y));
                     pointOfPaint.add(new Point(p1.x+10,p1.y));
                     pointOfPaint.add(new Point(p1.x+10,p2.y));
                     pointOfPaint.add(new Point(p2.x,p2.y));
                }else{
                     pointOfPaint.add(new Point(p1.x,p1.y));
                     pointOfPaint.add(new Point(p1.x,p2.y+incY));
                     pointOfPaint.add(new Point(p2.x-incX,p2.y+incY));
                     pointOfPaint.add(new Point(p2.x-incX,p2.y));
                     pointOfPaint.add(new Point(p2.x,p2.y));
                }
            }else{
                if(p1.x < p2.x)
				{
                     pointOfPaint.add(new Point(p1.x, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p2.y));
                     pointOfPaint.add(new Point(p2.x, p2.y));
                }else{
                     pointOfPaint.add(new Point(p1.x, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p1.y));
                     pointOfPaint.add(new Point(p1.x + 10, p2.y + incY));
                     pointOfPaint.add(new Point(p2.x - incX, p2.y + incY));
                     pointOfPaint.add(new Point(p2.x - incX, p2.y));
                     pointOfPaint.add(new Point(p2.x, p2.y));
                }
            }
        }
        
        /*
        * Disegna la linea in base a come e' stato inizializzato il pointOfPaint, prima facendo un moveTo
        * per capire da dove partire a disegnare e poi completare il collegamento, facendo le linee necessarie
        * con il resto dei punti caricati nell'array
        */
        if(!pointOfPaint.isEmpty())
		{
            ((GeneralPath)shape).reset();
            ((GeneralPath)shape).moveTo(pointOfPaint.get(0).x,pointOfPaint.get(0).y);
            for(int i = 1; i < pointOfPaint.size(); i++){
                ((GeneralPath)shape).lineTo(pointOfPaint.get(i).x,pointOfPaint.get(i).y);
            }
        }
    }

    public void refreshLink(Point p, boolean typelink) 
	{
        if (!typelink) {
            p2 = p;
        } else {
            p1 = p;
        }
        makeShape();
    }

    public Point containsSpot(Point p)
	{
        Point p3,p4;
        for(int i = 0; i < pointOfPaint.size()-1; i++)
		{
            p3 = pointOfPaint.get(i);
            p4 = pointOfPaint.get(i+1);
            if(p3.x==p4.x && ((p3.y<p4.y && p3.y<=p.y && p4.y>=p.y) ^ (p3.y>p4.y && p3.y>=p.y && p4.y<=p.y)) && p.x>=p3.x-5 && p.x<=p4.x+5)
                return new Point(p3.x,p.y);
            if(p3.y==p4.y && ((p3.x<p4.x && p3.x<=p.x && p4.x>=p.x) ^ (p3.x>p4.x && p3.x>=p.x && p4.x<=p.x)) && p.y>=p3.y-5 && p.y<=p4.y+5)
                return new Point(p.x,p3.y);
        }
        return null;
    }
}
