package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.awt.*;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.Observable;
import javax.swing.*;
import java.util.ArrayList;
import java.util.Observer;

public class MiddlePanel extends JPanel implements MouseListener, MouseMotionListener, Observer {

    int x0, y0, x, y,
            typetmpgate,
            preferedWidth = getWidth(),
            preferedHeight = getHeight();
    boolean out, //Indica se il cursore e' fuori dalla finestra
            drag, //Indica se il cursore e' trascinato
            spottmp, //Indica che e' in corso il collegamento di uno spot
            butgateact, //Indica se e' stato attivato un pulsante porta della toolbar 
            butlineact, //Indica se e' stato attivato il pulsante linea nella toolbar
            butspotact,
            componentdraggable = true, //Indica se e' possibile trascinare le porte
            circuitsimulate, //Indica se il circuito e' in esecuzione
            butrubber, //Indica che il pulsante gomma e' attivato
            doublespotsucc; //Indica se sono collegati due spot
    JGatePanel gatetmp;
    Image imggatetmp;
    Image imgspottmp;
    LinkShape lastlineshape;
    LinkShape linkshapetmp;
    InputPanel inputtmp;
    LedPanel outputtmp;
    MouseMotionListener[] mousemotionlisttmp;
    private Point corner1 = new Point(0, 0);
    private Point corner2 = new Point(0, 0);
    private Point pointtmp;
    ArrayList<MyShape> shapes = new ArrayList();
    ArrayList<InputPanel> inputpanel = new ArrayList();
    ArrayList<LedPanel> LedPanel = new ArrayList();
    GraphicsManager refGraphMan;

    public MiddlePanel() {
        LayoutManager overlay = new OverlayLayout(this) {

            @Override
            public void layoutContainer(Container target) {
                int nChildren = target.getComponentCount();

                for (int i = 0; i < nChildren; i++) {
                    Component c = target.getComponent(i);
                    c.setBounds(c.getLocation().x, c.getLocation().y,
                            c.getPreferredSize().width, c.getPreferredSize().height);
                }
            }
        };

        //Setup MiddlePanel
        setMaximumSize(new Dimension(800, 600));
        setBackground(Color.white);
        setFocusable(true);
        setLayout(overlay);
        addMouseListener(this);
        addMouseMotionListener(this);

        //Ascolta gli eventi generati dal resize del Panel
        addComponentListener(new ComponentAdapter() {

            @Override
            public void componentResized(ComponentEvent e) {
                super.componentResized(e);
                refreshLocationOutput();
            }
        });

        //Ascolta gli eventi generati da tastiera
        addKeyListener(new KeyAdapter() {

            @Override
            public void keyPressed(KeyEvent e) {
                super.keyPressed(e);
                if (e.getKeyCode() == 8 || e.getKeyCode() == 127) {
                    searchDeleteSelected();
                }
            }
        });
    }

    public void initializesRefGraphicsManager(GraphicsManager _g) {
        refGraphMan = _g;
    }

    public void refreshLocationOutput() {
        for (int i = 0; i < LedPanel.size(); i++) {
            LedPanel.get(i).setLocation(getWidth() - 20, LedPanel.get(i).getY());
            if (!LedPanel.get(i).linkinput.isEmpty()) {
                LedPanel.get(i).refreshLink();
            }
        }
    }

    //Cancella le porte selzionate
    public void searchDeleteSelected() {
        //Nascondo l'InfoGatePanel
        refGraphMan.hideInfoGatePanels();
        boolean trovato = false;
        int i = 0;
        while (!trovato && i < getComponentCount()) {
            if (getComponent(i) instanceof JGatePanel && ((JGatePanel) getComponent(i)).id == refGraphMan.getSelectedJLinkablePanel()) {
                trovato = true;
            } else {
                i++;
            }
        }
        if (trovato) {
            deleteGate((JGatePanel) getComponent(i));
        }
        clearSelection();
        repaint();
    }

    //Un metodo che restituisce se non c'e' il rischio di sovrappore i componenti figli
    @Override
    public boolean isOptimizedDrawingEnabled() {
        return false;
    }

    //Metodo che viene chiamato con il repaint(); 
    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        g.setColor(Color.LIGHT_GRAY);
        paintGateTmp(g);
        paintGrid(g);
        refreshShapes((Graphics2D) g);
        paintLineTmp(g);
        //paintSelection(g);
        paintSpot(g);
    }

    //Serve per disegnare una Shape qualsiasi sul pannello
    public void paintShape(Graphics g, MyShape s) {
        Graphics2D g2 = (Graphics2D) g;
        g2.setColor(Color.black);
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2.draw(s.getShape());
    }

    //Serve per creare un rettangolo per selezionare i componenti
    public void paintSelection(Graphics g) {
        int x = Math.min(corner1.x, corner2.x);
        int y = Math.min(corner1.y, corner2.y);
        int width = Math.abs(corner1.x - corner2.x);
        int height = Math.abs(corner1.y - corner2.y);

        g.setColor(Color.CYAN);
        g.drawRect(x, y, width, height);
        g.setColor(Color.BLUE);
        g.fillRect(x + 1, y + 1, width - 1, height - 1);
    }

    //Disegna la linea temporanea
    public void paintLineTmp(Graphics g) {
        ((Graphics2D) g).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        ((Graphics2D) g).setStroke(new BasicStroke(BasicStroke.CAP_SQUARE));
        if (inputtmp != null && butlineact) {
            g.setColor(Color.black);
            g.drawLine(inputtmp.effetiveLink.x, inputtmp.effetiveLink.y, x0, y0);
        }
        if (gatetmp != null && butlineact) {
            g.setColor(Color.black);
            g.drawLine(gatetmp.effetiveLink.x, gatetmp.effetiveLink.y, x0, y0);
        }
        if (outputtmp != null && butlineact) {
            g.setColor(Color.black);
            g.drawLine(outputtmp.effetiveLink.x, outputtmp.effetiveLink.y, x0, y0);
        }
        if (imgspottmp != null && pointtmp != null) {
            g.setColor(Color.black);
            g.drawLine(pointtmp.x, pointtmp.y, x0, y0);
        }
    }

    //Disegna la porta temporanea
    public void paintGateTmp(Graphics g) {
        if (butgateact) {
            g.drawImage(imggatetmp, x0 - 24, y0 - 24, this);
            g.setColor(Color.DARK_GRAY);  //Cambia il colore della griglia momentaneamente
        }
    }

    //Disegna la griglia
    public void paintGrid(Graphics g) {
        for (int i = 0; i < getWidth() || i < getHeight(); i += 20) {
            g.drawLine(i, 0, i, getHeight());
            g.drawLine(0, i, getWidth(), i);
        }
    }

    //Crea una porta passando l'immagine temporanea utilizzata, la posizione del mouse, e' una costante passata dal core (Da sistemare)
    public JGatePanel createGate(MouseEvent e) {
        JGatePanel Jglbl = new JGatePanel(imggatetmp, e);
        Jglbl.setId(typetmpgate, refGraphMan.createGateOrSpotInModel(typetmpgate, Jglbl.getX(), Jglbl.getY()));
        refGraphMan.createLinkableInfo(Jglbl);
        refresh(Jglbl, e);
        add(Jglbl);
        refGraphMan.refreshValue();
        refGraphMan.refreshAliasPanel(Jglbl.id);
        refGraphMan.clearSelectionToolBar();
        requestFocusInWindow();
        return Jglbl;
    }

    //Cancella una porta
    public boolean deleteGate(JGatePanel JGP) {
        refGraphMan.deleteGateInModel(JGP.id);
        isolateLinkablePanel(JGP);
        remove(JGP);
        refGraphMan.deleteLinkableInfo(JGP);
        return true;
    }

    //Cancella uno spot e tutte le linee ad esso collegato
    public boolean deleteSpot(JSpotPanel JGP) {
        isolateLinkablePanel(JGP);
        remove(JGP);
        refGraphMan.deleteGateInModel(JGP.id);
        return true;
    }

    //Cancella uno spot e ricollega le porte che erano collegate
    public boolean deleteSpotAndConnect(JSpotPanel JGP, int idtmp) {
        boolean doConnect = true;
        JLinkablePanel tmpCompBeg = null;
        JLinkablePanel tmpCompEnd = null;
        LinkShape tmpLine = null;

        //Faccio questo if per settare il currentPin giusto dello spot
        if (!JGP.linkinput.isEmpty()) {
            if (JGP.linkinput.get(0).line.inputgate instanceof JSpotPanel) {
                if (JGP.linkinput.get(0).line.pinI == 0) {
                    JGP.linkinput.get(0).line.inputgate.currentPin = 0;
                } else {
                    JGP.linkinput.get(0).line.inputgate.currentPin = 1;
                }
            }
            tmpCompBeg = JGP.linkinput.get(0).line.inputgate;
        }

        //Idtmp e' l'id della porta che stai cancellando
        if (idtmp == JGP.linkoutput.get(0).line.outputgate.id) {
            if (JGP.linkoutput.size() < 2 || idtmp == JGP.linkoutput.get(1).line.outputgate.id) {
                doConnect = false;
            } else {
                tmpLine = JGP.linkoutput.get(1).line;
            }
        } else {
            tmpLine = JGP.linkoutput.get(0).line;
        }


        int PiedinoI = JGP.linkinput.get(0).line.pinI;
        int PiedinoU = 0;
        if (tmpLine != null) {
            tmpCompEnd = tmpLine.outputgate;
            tmpCompEnd.currentPin = tmpLine.pinO;
            PiedinoU = tmpCompEnd.currentPin;
        }

        //Cancello lo spot
        Point p1 = JGP.linkinput.get(0).line.p1;
        isolateSpotPanel(JGP);
        remove(JGP);

        refGraphMan.deleteGateInModel(JGP.id);

        //Controllo se collegare l'ingresso dell'uscita dello spot all'uscita della porta a cui era collegato l'ingresso dello spot.

        if (doConnect) {
            shapes.add(new LinkShape(tmpCompBeg, tmpCompEnd, refGraphMan.createLinkInModel(tmpCompBeg.id, tmpCompEnd.id, PiedinoI, PiedinoU)));
            tmpCompBeg.linkoutput.add(new LinkOutput(p1, (LinkShape) shapes.get(shapes.size() - 1), PiedinoI));
            tmpCompEnd.linkinput.add(new LinkInput(tmpLine.p2, (LinkShape) shapes.get(shapes.size() - 1), PiedinoU));
        }

        refreshAllComponentsLink();
        return true;
    }

    //Creo uno spot
    public JSpotPanel createSpot() {
        JSpotPanel Jglbl = new JSpotPanel(imgspottmp, pointtmp, linkshapetmp, refGraphMan.createGateOrSpotInModel(Data.POINT, pointtmp.x, pointtmp.y));
        refGraphMan.clearSelectionToolBar();
        return Jglbl;
    }

    public void paintSpot(Graphics g) {
        if (pointtmp != null) {
            g.drawImage(imgspottmp, pointtmp.x - 3, pointtmp.y - 3, this);
        }
    }

    //Refresha quando l'oggetto e' una JGateLabel 
    public void refresh(JLinkablePanel j, MouseEvent e) {
        moveScroolBar(e.getPoint(), j);
        refreshGrid(j);
        refresh();
    }

    //Refresha tutto il middlepanel chiamandosi in cascata tutti i metodi che permettono il refresh totale del panel 
    public void refresh() {
        refreshShapes((Graphics2D) getGraphics());
        refreshAllComponentsLink();
        revalidate();
        repaint();
    }

    //Refresha tutti i link dei JLinkablePanel
    public void refreshAllComponentsLink() {
        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponent(i) instanceof JGatePanel) {
                ((JGatePanel) getComponent(i)).refreshPositionLink();
            }
        }
    }

    //Refresha tutte le Shape contenute nel MiddlePanel
    public void refreshShapes(Graphics2D g2) {
        for (int i = 0; i < shapes.size(); i++) {
            g2.setStroke(new BasicStroke(BasicStroke.CAP_SQUARE));
            g2.setColor(Color.black);
            g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
            g2.draw(shapes.get(i).getShape());
        }
    }

    //Muove la scroll bar solo se il cursore e' fuori dal Frame
    public void moveScroolBar(Point p, JLinkablePanel c) {
        if (!refGraphMan.isOnScreenOfMiddlePanel(c) && refGraphMan.isOutMouse()) {
            refGraphMan.mySetJViewport(MouseInfo.getPointerInfo().getLocation(), c);
        }
    }

    //Aggiorna la griglia, estendola (farla ridurre se necessario da sistemare) 
    public void refreshGrid(JLinkablePanel j) {
        int inc = 0;
        if (j instanceof LedPanel || j instanceof InputPanel) {
            inc = 20;
        }
        if ((j.getX() + j.getWidth()) > preferedWidth) {
            preferedWidth = j.getX() + j.getWidth();
        }
        if ((j.getY() + j.getHeight() > preferedHeight)) {
            preferedHeight = j.getY() + j.getHeight() + inc;
        }
        setPreferredSize(new Dimension(preferedWidth, preferedHeight));
    }

    //Vede se cliccando trovo un inputPanel e nel caso memorizza il reference
    public InputPanel searchInputPanel(Point p) {
        for (int i = 0; i < inputpanel.size(); i++) {
            if (inputpanel.get(i).contains(p)) {
                return inputpanel.get(i);
            }
        }
        return null;
    }

    //L'oggetto Point passato tra i parametri e' il secondo punto dove si collega la linea 
    public void connect(JLinkablePanel JLP) {

        //Nel caso si stia collegando da un line a un altro JLinkablePanel
        if (inputtmp != null && !spottmp) {
            shapes.add(new LinkShape(inputtmp, JLP, refGraphMan.createLinkInModel(inputtmp.id, JLP.id, inputtmp.currentPin, JLP.currentPin)));
            inputtmp.linkoutput.add(new LinkOutput(inputtmp.effetiveLink, (LinkShape) shapes.get(shapes.size() - 1), inputtmp.currentPin));
            refGraphMan.refreshAliasPanel(inputtmp.id);
            inputtmp = null;
            componentdraggable = true;
        }

        //Nel caso si stia collegando da una porta a un altro JLinkablePanel che non sia un LedPanel
        if (gatetmp != null && JLP.typelink && !spottmp) {
            shapes.add(new LinkShape(JLP, gatetmp, refGraphMan.createLinkInModel(JLP.id, gatetmp.id, JLP.currentPin, gatetmp.currentPin)));
            gatetmp.linkinput.add(new LinkInput(gatetmp.effetiveLink, (LinkShape) shapes.get(shapes.size() - 1), gatetmp.currentPin));
            refGraphMan.refreshAliasPanel(gatetmp.id);
            gatetmp = null;
            componentdraggable = true;
        }

        //Nel caso si stia collegando da una porta a un altro JLinkablePanel che non sia un InputPanel
        if (gatetmp != null && !JLP.typelink && !spottmp) {
            int tmp2ID = refGraphMan.createLinkInModel(gatetmp.id, JLP.id, gatetmp.currentPin, JLP.currentPin);
            shapes.add(new LinkShape(gatetmp, JLP, tmp2ID));
            gatetmp.linkoutput.add(new LinkOutput(gatetmp.effetiveLink, (LinkShape) shapes.get(shapes.size() - 1), gatetmp.currentPin));
            refGraphMan.refreshAliasPanel(gatetmp.id);
            gatetmp = null;
            componentdraggable = true;
        }

        //Nel caso si stia colleagando da un Output a un altro JLinkablePanel
        if (outputtmp != null && !spottmp) {
            shapes.add(new LinkShape(JLP, outputtmp, refGraphMan.createLinkInModel(JLP.id, outputtmp.id, JLP.currentPin, outputtmp.currentPin)));
            outputtmp.linkinput.add(new LinkInput(outputtmp.effetiveLink, (LinkShape) shapes.get(shapes.size() - 1), outputtmp.currentPin));
            refGraphMan.refreshAliasPanel(outputtmp.id);
            outputtmp = null;
            componentdraggable = true;
        }

        /*
         * Nel caso si stia collegando uno spot con un altro JLinkablePanel, il boolean viene settato a true
         * nel MouseClicked del MiddlePanel dopo che viene invocato il metodo getLinkShape
         */
        if (spottmp) {
            JSpotPanel spot = createSpot();
            add(spot);
            spot.currentPin = 1;
            if (spot.linkoutput.get(0).line.outputgate.equals(JLP)) {
                JLP.currentPin = Math.abs(JLP.currentPin - 1);
            }
            int tmp3ID = refGraphMan.createLinkInModel(spot.id, JLP.id, spot.currentPin, JLP.currentPin);
            shapes.add(new LinkShape(spot, JLP, tmp3ID));
            spot.linkoutput.add(new LinkOutput(spot.effetiveLink, (LinkShape) shapes.get(shapes.size() - 1), 1));
            refGraphMan.clearSelectionToolBar();
            requestFocusInWindow();
            linkshapetmp = null;
            imgspottmp = null;
            pointtmp = null;
            spottmp = false;
            componentdraggable = true;
            refreshAllComponentsLink();
        }

        refresh();
        refGraphMan.refreshValue();
        refGraphMan.refreshAliasPanel(JLP.id);
        refGraphMan.clearSelectionToolBar();
        lastlineshape = (LinkShape) shapes.get(shapes.size() - 1);
        butlineact = false;
    }

    @Override
    public void mouseClicked(MouseEvent e) {

        //Carica in linkshapetmp se c'e' nel punto cliccato un link shape
        if (butspotact) {
            linkshapetmp = getLinkShape(e.getPoint());
            if (linkshapetmp != null) {
                butspotact = false;
            }
        }

        //Crea la porta se c'era un pulsante gate della ToolBar selezionato
        if (butgateact && SwingUtilities.isLeftMouseButton(e)) {
            butgateact = false;
            setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            createGate(e);
        }

        //Disabilita il collegamento di uno spot
        if (pointtmp != null && SwingUtilities.isRightMouseButton(e)) {
            linkshapetmp = null;
            imgspottmp = null;
            pointtmp = null;
            spottmp = false;
        }

        //Creo uno spot
        if (imgspottmp != null && linkshapetmp != null) {
            Point _pointtmp = linkshapetmp.containsSpot(e.getPoint());
            if (_pointtmp != null) {
                pointtmp = _pointtmp;
                spottmp = true;
                setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
            }
        }

        //Dice alla toolbar che c'e' il pulsante crea spot ancora attivato
        if (pointtmp != null) {
            refGraphMan.buttonSelectedToolBar();
        }

        //Cancella una Line Shape
        if (butrubber) {
            linkshapetmp = getLinkShape(e.getPoint());
            if (linkshapetmp != null && (!(linkshapetmp.inputgate instanceof JSpotPanel) && !(linkshapetmp.outputgate instanceof JSpotPanel))) {
                deleteLinkShape(linkshapetmp);
            }
            if (linkshapetmp != null && ((linkshapetmp.inputgate instanceof JSpotPanel) && !(linkshapetmp.outputgate instanceof JSpotPanel))) {
                deleteSpotAndConnect(((JSpotPanel) linkshapetmp.inputgate), linkshapetmp.outputgate.id);
            }
            if (linkshapetmp != null && (!(linkshapetmp.inputgate instanceof JSpotPanel) && (linkshapetmp.outputgate instanceof JSpotPanel))) {
                deleteSpot(((JSpotPanel) linkshapetmp.outputgate));
            }
            if (linkshapetmp != null && ((linkshapetmp.inputgate instanceof JSpotPanel) && (linkshapetmp.outputgate instanceof JSpotPanel))) {
                deleteSpot(((JSpotPanel) linkshapetmp.outputgate));
            }
        }

        requestFocus();
        clearSelection();

        if (SwingUtilities.isRightMouseButton(e)) {
            typetmpgate = 0;
            componentdraggable = true;
            drag = false;
            butlineact = false;
            butgateact = false;
            butspotact = false;
            butrubber = false;
            imggatetmp = null;
            gatetmp = null;
            inputtmp = null;
            outputtmp = null;
            refGraphMan.hideInfoGatePanels();
            refGraphMan.clearSelectionToolBar();
            setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
        }
        repaint();
    }

    @Override
    public void mousePressed(MouseEvent e) {
        corner1 = e.getPoint();
        corner2 = corner1;
        repaint();
    }

    @Override
    public void mouseReleased(MouseEvent e) {
        corner1 = e.getPoint();
        corner2 = corner1;
        repaint();
    }

    @Override
    public void mouseEntered(MouseEvent e) {
        out = false;
        repaint();
    }

    @Override
    public void mouseExited(MouseEvent e) {
        out = true;
        repaint();
    }

    @Override
    public void mouseDragged(MouseEvent e) {
        corner2 = e.getPoint();
        drag = true;
        repaint();
    }

    @Override
    public void mouseMoved(MouseEvent e) {
        x0 = e.getX();
        y0 = e.getY();
        drag = false;
        repaint();
    }

    //Setta l'immagine temporanea da visualizzare prima dell'inserimento effettivo
    public void setImageGateTmp(Image i, int id) {
        setCursor(new Cursor(Cursor.MOVE_CURSOR));
        typetmpgate = id;
        imggatetmp = i;
        butgateact = true;
    }

    //Setta il numero di line, il metodo viene chiamato dal ChangeListener degli JSpinner del SouthPanel
    public void setInputPanel(int n) {
        if (n >= inputpanel.size()) {
            for (int i = inputpanel.size(); i < n; i++) {
                inputpanel.add(new InputPanel(i * 40 + 20, refGraphMan.insertInput()));
                add(inputpanel.get(inputpanel.size() - 1));
                refreshGrid(inputpanel.get(inputpanel.size() - 1));
                inputpanel.get(inputpanel.size() - 1).textlabel.setLocation(0, i * 40);
                inputpanel.get(inputpanel.size() - 1).textlabel.setPreferredSize(new Dimension(40, 20));
                inputpanel.get(inputpanel.size() - 1).textlabel.setText("");
                inputpanel.get(inputpanel.size() - 1).textlabel.addActionListener(new ActionListener() {

                    @Override
                    public void actionPerformed(ActionEvent e) {
                        refGraphMan.setNameOfInput(e, ((MYJTextField) e.getSource()).idinput, ((JTextField) e.getSource()).getText());
                    }
                });

                add(inputpanel.get(inputpanel.size() - 1).textlabel);
                refreshGrid(inputpanel.get(inputpanel.size() - 1));
                refGraphMan.createLinkableInfo(inputpanel.get(inputpanel.size() - 1));
            }
        } else {
            for (int i = inputpanel.size() - 1; i >= n; i--) {
                refGraphMan.deleteInputInModel(inputpanel.get(i).id);
                refGraphMan.deleteLinkableInfo(inputpanel.get(i));
                remove(inputpanel.get(i).textlabel);
                remove(inputpanel.get(i));
                isolateLinkablePanel(inputpanel.get(i));
                inputpanel.remove(i);
            }
        }
        refresh();
    }

    //Setta il numero di line, il metodo viene chiamato dal ChangeListener degli JSpinner del SouthPanel
    public void setLedPanel(int n) {
        if (n >= LedPanel.size()) {
            for (int i = LedPanel.size(); i < n; i++) {
                LedPanel.add(new LedPanel(i * 40 + 30, getWidth(), refGraphMan.insertOutput()));
                add(LedPanel.get(LedPanel.size() - 1));
                refreshGrid(LedPanel.get(LedPanel.size() - 1));
                refGraphMan.createLinkableInfo(LedPanel.get(LedPanel.size() - 1));
            }
        } else {
            for (int i = LedPanel.size() - 1; i >= n; i--) {
                refGraphMan.deleteOutputInModel(LedPanel.get(i).id);
                refGraphMan.deleteLinkableInfo(LedPanel.get(i));
                remove(LedPanel.get(i));
                isolateLinkablePanel(LedPanel.get(i));
                LedPanel.remove(i);
            }
        }
        refresh();
    }

    public void clearSelection() {
        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponent(i) instanceof JLinkablePanel) {
                ((JLinkablePanel) getComponent(i)).selected = false;
            }
        }
        refGraphMan.setMenuEnabled(1, false);
        repaint();
    }

	/*
    public void optimizesSpace() {
        for (int i = 0; i < getComponentCount(); i++) {
			if (getComponent(i).getX() + getComponent(i).getWidth() < preferedWidth) {
                preferedWidth = getComponent(i).getX() + getComponent(i).getWidth();
            }
			if (getComponent(i).getY() + getComponent(i).getHeight() < preferedHeight) {
                preferedHeight = getComponent(i).getY() + getComponent(i).getHeight();
            }
        }

        //Controlla se le dimensioni sono piu' piccole della JViewport
		if (preferedWidth > refGraphMan.getViewPortMiddlePanel().getWidth()) {
            preferedWidth = refGraphMan.getViewPortMiddlePanel().getWidth();
        }
        if (preferedHeight > refGraphMan.getViewPortMiddlePanel().getHeight()) {
            preferedHeight = refGraphMan.getViewPortMiddlePanel().getHeight();
        }
		
        //Riallinea gli line
        for (int i = 0; i < LedPanel.size(); i++) {
            LedPanel.get(i).setLocation(getWidth() - 20, LedPanel.get(i).getY());
            if (!LedPanel.get(i).linkinput.isEmpty()) {
                LedPanel.get(i).refreshLink();
            }
        }

        refGraphMan.getViewPortMiddlePanel().setViewPosition(new Point(preferedWidth - getWidth(), preferedHeight - getHeight()));
        setPreferredSize(new Dimension(preferedWidth, preferedHeight));
    }
	*/
	public void optimizesSpace(){
		int maxx = 0;
		int maxy = 0;
		for(int i=0;i<getComponentCount();i++){
			if(getComponent(i).getX()+getComponent(i).getWidth()>maxx)
				maxx = getComponent(i).getX()+getComponent(i).getWidth();
			if(getComponent(i).getY()+getComponent(i).getHeight()>maxy)
				maxy = getComponent(i).getY()+getComponent(i).getHeight();
		}
		 refGraphMan.getViewPortMiddlePanel().setViewPosition(new Point(maxx-getWidth(),maxy-getHeight()));
		setPreferredSize(new Dimension(maxx,maxy));
	}
    public void isolateLinkablePanel(JLinkablePanel JLP) {
        while (!JLP.linkinput.isEmpty()) {
            if (JLP.linkinput.get(0).line.inputgate instanceof JSpotPanel && !doublespotsucc) {
                deleteSpotAndConnect((JSpotPanel) JLP.linkinput.get(0).line.inputgate, JLP.id);
            } else {
                if (JLP.linkinput.get(0) != null) {
                    shapes.remove(JLP.linkinput.get(0).deleteLinkShape());
                }
            }
        }

        while (!JLP.linkoutput.isEmpty()) {
            if (JLP.linkoutput.get(0).line.outputgate instanceof JSpotPanel) {
                doublespotsucc = true;
                deleteSpot((JSpotPanel) JLP.linkoutput.get(0).line.outputgate);
            } else {
                if (JLP.linkoutput.get(0) != null) {
                    shapes.remove(JLP.linkoutput.get(0).deleteLinkShape());
                }
            }
        }
        doublespotsucc = false;
        repaint();
    }

    public void isolateSpotPanel(JLinkablePanel JLP) {
        while (!JLP.linkinput.isEmpty()) {
            shapes.remove(JLP.linkinput.get(0).deleteLinkShape());
        }

        while (!JLP.linkoutput.isEmpty()) {
            shapes.remove(JLP.linkoutput.get(0).deleteLinkShape());
        }
        repaint();
    }

    public void refreshValueGate() {
        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponent(i) instanceof JGatePanel) {
                for (int j = 0; j < ((JGatePanel) getComponent(i)).ci.length; j++) {
                    if (refGraphMan.getValueJLinkablePanelInput(((JGatePanel) getComponent(i)), j)) {
                        ((JGatePanel) getComponent(i)).ci[j] = '1';
                    } else {
                        ((JGatePanel) getComponent(i)).ci[j] = '0';
                    }
                }
                for (int j = 0; j < ((JGatePanel) getComponent(i)).co.length; j++) {
                    if (refGraphMan.getValueJLinkablePanelOutput(((JGatePanel) getComponent(i)), j)) {
                        ((JGatePanel) getComponent(i)).co[j] = '1';
                    } else {
                        ((JGatePanel) getComponent(i)).co[j] = '0';
                    }
                }
            }
        }
    }

    public void refreshValueOutput() {
        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponent(i) instanceof LedPanel) {
                for (int j = 0; j < ((LedPanel) getComponent(i)).ci.length; j++) {
                    if (refGraphMan.getValueJLinkablePanelInput(((LedPanel) getComponent(i)), j)) {
                        ((LedPanel) getComponent(i)).ci[j] = '1';
                        ((LedPanel) getComponent(i)).setValueOutput(true);
                        refGraphMan.refreshAliasPanel(((LedPanel) getComponent(i)).id);
                    } else {
                        ((LedPanel) getComponent(i)).setValueOutput(false);
                        ((LedPanel) getComponent(i)).ci[j] = '0';
                    }
                }
            }
        }
    }

    //Controlla se c'e' una linea
    public LinkShape getLinkShape(Point p) {
        for (int i = 0; i < shapes.size(); i++) {
            for (int j = -3; j < 3; j++) {
                for (int k = -3; k < 3; k++) {
                    if (shapes.get(i).getShape().contains(new Point(p.x + j, p.y + k))) {
                        return (LinkShape) shapes.get(i);
                    }
                }
            }
        }
        return null;
    }

    //Da sistemare
    public void deleteLinkShape(LinkShape s) {
        int i = 0;
        while (i < s.outputgate.linkinput.size()) {
            if (s.outputgate.linkinput.get(i).getId() == s.pinO) {
                s.outputgate.currentPin = s.pinO;
                s.outputgate.linkinput.remove(i);
            } else {
                i++;
            }
        }
        i = 0;
        while (i < s.inputgate.linkoutput.size()) {
            if (s.inputgate.linkoutput.get(i).getId() == s.pinI) {
                s.inputgate.currentPin = s.pinI;
                s.inputgate.linkoutput.remove(i);
            } else {
                i++;
            }
        }
        Startup.core.deleteLink(s.id);
        shapes.remove(s);
    }

    public boolean chkPath(Point p1, Point p2) {

        for (int i = 0; i < getComponentCount(); i++) {
            if ((getComponent(i).getX() > p1.x && getComponent(i).getX() < p2.x) || (getComponent(i).getY() > p1.y && getComponent(i).getY() < p2.y)) {
                return false;
            }
        }

        return true;
    }

    public void disableComponents() {
        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponent(i) instanceof JGatePanel) {
                getComponent(i).setEnabled(false);
                ((JGatePanel) getComponent(i)).popupmenu.setEnabled(false);
            }
            if (getComponent(i) instanceof InputPanel) {
                ((InputPanel) getComponent(i)).popupmenu.setEnabled(false);
            }
            if (getComponent(i) instanceof LedPanel) {
                getComponent(i).setEnabled(false);
                ((LedPanel) getComponent(i)).popupmenu.setEnabled(false);
            }
            if (getComponent(i) instanceof JTextField) {
                getComponent(i).setEnabled(false);
            }
        }
    }

    public void enableComponents() {
        for (int i = 0; i < getComponentCount(); i++) {
            getComponent(i).setEnabled(true);
            if (getComponent(i) instanceof JGatePanel) {
                ((JGatePanel) getComponent(i)).popupmenu.setEnabled(true);
            }
            if (getComponent(i) instanceof InputPanel) {
                ((InputPanel) getComponent(i)).popupmenu.setEnabled(true);
            }
            if (getComponent(i) instanceof LedPanel) {
                ((LedPanel) getComponent(i)).popupmenu.setEnabled(true);
            }
        }
    }

    public boolean isAboveJLinkablePanel(JLinkablePanel JLP) {
        Point ptmpcul = new Point(JLP.getLocation().x, JLP.getLocation().y);
        Point ptmpcur = new Point(JLP.getLocation().x + JLP.getWidth(), JLP.getLocation().y);
        Point ptmpcdl = new Point(JLP.getLocation().x, JLP.getLocation().y + JLP.getHeight());
        Point ptmpcdr = new Point(JLP.getLocation().x + JLP.getWidth(), JLP.getLocation().y + JLP.getHeight());

        for (int i = 0; i < getComponentCount(); i++) {
            if (getComponentZOrder(JLP) != i) {
                if (getComponent(i) instanceof JLinkablePanel
                        && (contains((JLinkablePanel) getComponent(i), ptmpcul)
                        || contains((JLinkablePanel) getComponent(i), ptmpcur)
                        || contains((JLinkablePanel) getComponent(i), ptmpcdl)
                        || contains((JLinkablePanel) getComponent(i), ptmpcdr))) {
                    return true;
                }
            }
        }
        return false;
    }

    public boolean contains(JLinkablePanel j, Point p) {
        if (p.x >= j.getX() - 1
                && p.x <= j.getX() + j.getWidth() + 1
                && p.y >= j.getY() - 1
                && p.y <= j.getY() + j.getHeight() + 1) {
            return true;
        }
        return false;
    }

    public void disableButtonTmpMiddlePanel() {
        butlineact = false;
        butgateact = false;
    }

    public void reset(){
        removeAll();
        shapes.clear();
    }
    
    @Override
    public void update(Observable o, Object arg) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}