package LCE.view;

import LCE.*;
import LCE.controller.*;
import LCE.model.*;

import java.net.*;
import java.awt.*;
import javax.swing.*;

public class ToolGateBar extends JToolBar {

    JButton and;
    JButton or;
    JButton nand;
    JButton nor;
    JButton xor;
    JButton nxor;
    JButton not;
    JButton line;
    JButton spot;
    JButton rubber;
    
    URL urlAND = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/and.gif");
    URL urlOR = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/or.gif");
    URL urlNAND = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/nand.gif");
    URL urlNOR = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/nor.gif");
    URL urlXOR = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/xor.gif");
    URL urlNXOR = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/nxor.gif");
    URL urlNOT = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/Gate/not.gif");
    URL urlLINE = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/line.gif");
    URL urlSPOT = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/spot.gif");
    URL  urlRUBBER = Startup.class.getClassLoader().getResource(Startup.pathMain + "img/rubber.gif");
    
    public boolean butselected = false;
    
    GraphicsManager refGraphicsManager;

    public ToolGateBar() 
	{

        super("Tool Gate Bar");
    
        and = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlAND), Data.AND_GATE);
        and.setToolTipText("AND gate");
        
        or = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlOR), Data.OR_GATE);
        or.setToolTipText("OR gate");
        
        nand = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlNAND), Data.NAND_GATE);
        nand.setToolTipText("NAND gate");
        
        nor = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlNOR), Data.NOR_GATE);
        nor.setToolTipText("NOR gate");
        
        xor = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlXOR), Data.XOR_GATE);
        xor.setToolTipText("XOR gate");
        
        nxor = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlNXOR), Data.NXOR_GATE);
        nxor.setToolTipText("NXOR gate");
        
        not = new JGateButton(Toolkit.getDefaultToolkit().getImage(urlNOT), Data.NOT_GATE);
        not.setToolTipText("NOT gate");
        
        line = new JLineButton(Toolkit.getDefaultToolkit().getImage(urlLINE));
        line.setToolTipText("Line");
        
        spot = new JSpotButton(Toolkit.getDefaultToolkit().getImage(urlSPOT));
        spot.setToolTipText("Junction");
        
        rubber = new JRubberButton(Toolkit.getDefaultToolkit().getImage(urlRUBBER));
        rubber.setToolTipText("DeleteLine");
        
        add(and);
        add(or);
        add(nand);
        add(nor);
        add(xor);
        add(nxor);
        add(not);
        add(line);
        add(spot);
        add(rubber);
    }
    
    public void clearSelection(){
        for(int i = 0; i < getComponentCount(); i++){
            ((JButton)getComponent(i)).setOpaque(false);
            getComponent(i).repaint();
        }
        butselected = false;
    }
    
    public void disableToolBar(){
        for(int i = 0; i < getComponentCount(); i++){
            getComponent(i).setEnabled(false);
        }
    }
    
    public void enableToolBar(){
        for(int i = 0; i < getComponentCount(); i++){
            getComponent(i).setEnabled(true);
        }
    }
    
    //Avvisa che è stato selezionato un pulsante
    public void selectedButton(){
        butselected = true;
    }
    
    //Inizializza il riferimento al GraphicsManager
    public void initializesGraphicsManager(GraphicsManager _g) 
	{
        refGraphicsManager = _g;
        for(int i = 0; i < getComponentCount();i++){
            if(getComponent(i) instanceof JGateButton) ((JGateButton)getComponent(i)).initializesGraphicsManager(_g);
            if(getComponent(i) instanceof JLineButton) ((JLineButton)getComponent(i)).initializesGraphicsManager(_g);
            if(getComponent(i) instanceof JSpotButton) ((JSpotButton)getComponent(i)).initializesGraphicsManager(_g);
            if(getComponent(i) instanceof JRubberButton) ((JRubberButton)getComponent(i)).initializesGraphicsManager(_g);
        }
    }
}